Subject: bug#24714: delete-directory race condition

From: Glenn Morris <[email-masked]>
Date: Sun, 16 Oct 2016 22:20:45 -0400

Package: emacs
Version: 25.1

On current Debian testing, many tests in package-test.el fail for me with:

    Test package-test-update-listing condition:
    (file-error "Removing old name" "No such file or directory"
    "/tmp/pkg-test-user-dir-27293kBj/gnupg/S.gpg-agent.rstrd")

I believe this is due to a race condition in delete-directory.
Emacs seems to be lacking an equivalent of "rm -rf".

(delete-directory "/tmp/foo")

will fail with "No such file or directory" if a file in /tmp/foo
happen to be deleted by some other process in between the time that
delete-directory calls directory-files and the time it calls delete-file.